<?php

/* Copyright (c) 2014 Anemos s.r.o. All rights reserved. */

class SynoFileHostingMultishare {

    private $Url;
    private $Username;
    private $Password;
    private $HostInfo;
    private $MS_API = "https://www.multishare.cz/api/";
    private $log = TRUE;

    public function __construct($Url, $Username, $Password, $HostInfo) {
        $this->Url = $Url;
        $this->Username = $Username;
        $this->Password = $Password;
        $this->HostInfo = $HostInfo;
    }

    //This function returns download url.
    public function GetDownloadInfo() {
        // check user account
        if ($this->Verify() == LOGIN_FAIL) {
            return array(DOWNLOAD_ERROR => LOGIN_FAIL);
        }

        // check existence of file
        $fileInfo = $this->getUrl($this->MS_API . "?sub=check-file&link={$this->Url}");
        if (substr($fileInfo, 0, 3) == "ERR") {
            return array(DOWNLOAD_ERROR => ERR_FILE_NO_EXIST);
        }

        // everything is OK - return DL url
        $dlInfo = json_decode($this->getUrl($this->MS_API . "?sub=download-link&login={$this->Username}&password={$this->Password}&link={$this->Url}"));
        return array(DOWNLOAD_URL => $dlInfo->link);
    }

    public function Verify($ClearCookie = NULL) {
        $user = json_decode($this->getUrl($this->MS_API . "?sub=account-details&login={$this->Username}&password={$this->Password}"));
        if (is_numeric($user->ID)) {
            return USER_IS_PREMIUM;
        } else {
            return LOGIN_FAIL;
        }
    }

    private function getUrl($url) {
        $session = curl_init($url);
        @curl_setopt($session, CURLOPT_HEADER, false);
        @curl_setopt($session, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.10) Gecko/2009042523 Ubuntu/9.04 (jaunty) Firefox/3.0.10');
        @curl_setopt($session, CURLOPT_FOLLOWLOCATION, true);
        @curl_setopt($session, CURLOPT_TIMEOUT, 15);
        @curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
        @curl_setopt($session, CURLOPT_SSL_VERIFYPEER, false);
        $response = curl_exec($session);
		$this->log($response);
        return $response;
    }

    private function log($text) {
        if ($this->log) {
            file_put_contents("/tmp/MultiShare.log", $text . "\n", FILE_APPEND);
        }
    }

}
